// $Author: jmartin $
// $Date: 1997-12-05 01:57:18 $
// $Source: /root/cvs/Rigi/rigiedit/UT/src/avlnew.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

// avlnew.h

#ifndef _avlnew
#define _avlnew

extern const int INVALID;
extern const int PROBEONLY;

typedef unsigned long int AvlInfo;
typedef const char *AvlName;

struct avlrecord
{
    //int lean;

    AvlInfo info;
    AvlName name;

    struct avlrecord *left;
    struct avlrecord *right;
};

typedef struct avlrecord AvlRecord;
typedef AvlRecord *AvlSet;

extern AvlInfo*		AvlSetInfo( AvlSet*, AvlName, AvlInfo );

extern int		FreeSet( AvlSet* );
extern int		FreeSet( AvlSet*, void (*)(AvlName,AvlInfo*) );
extern int		SetSize( AvlSet );

extern AvlInfo		AvlIterate( AvlSet, int (*)(AvlName,AvlInfo) );
extern AvlInfo		AvlIterate( AvlSet, int (*)(AvlName) );

extern void		AvlMem(int*,int*,int*);
extern const AvlName	AvlLastName();

extern int		PrintSet( AvlSet );
extern int		PrintDictionary();

/*
    Description:

    PrintSet() dumps out the set, with size info.
    FreeSet() frees the set. If a function pointer is provided, it
	is applied to each member of the set (useful for freeing up
	memory associated with each set member). 

    AvlSetInfo( a,s,i ) sets the info for s to i, and returns the address
	of that info, stored in the set. If i is PROBEONLY, only searching
	(ie, no new record is created). In this case, NULL is returned if
	s is not in the set. If i is NULL, the info is not affected,
	though it is stored and initialized as NULL if not already there.

	If i is INVALID, if info already there, address returned, else
	a record with info INVALID is stored, and NULL is returned.

	Because of NULL (0), INVALID (-1), and PROBEONLY (-2), valid info
	should not be any of these values!!

    AvlIterate() goes through the set in order, until the callback function
	returns non-zero.

    AvlLastName() returns the last AvlName stored in the set. It is local
	memory, so it is necessarily const.
*/
#endif

// ------------------------------------------------------------------------
//
// $Log: not supported by cvs2svn $
//   Revision 1.5  1995/10/25  20:47:45  mwhitney
//   many changes
//
//   Revision 1.4  1995/10/04  17:30:19  mwhitney
//   *** empty log message ***
//
//   Revision 1.3  1994/10/07  18:19:36  mwhitney
//   minor
//
//   Revision 1.2  1994/08/29  18:14:31  mwhitney
//   minor
//
//   Revision 1.1  1994/08/17  20:48:12  mwhitney
//   Initial revision
//
//
