#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	"sexps.h"

static void parse_callback( char*,int,int,int );
static void rsf_out( char*, char*, char* );

static FILE *ofp = stdout;
static char *format = "%-15s %-15s %s\n";

static int nobjects = 0;
static int debug = 0;

static int nrsf=0, nout=0;

void main( int argc, char *argv[] )
{
    FILE *fp = stdin;
    char *filename = NULL;
    char *progname = *argv;

    // process arguments

    while (--argc)

        if (**++argv=='-') while (*++*argv) switch (**argv)
        {
            case 'd':   debug = 1;      break;
            default :   fprintf( stderr,"error, bad option -%c\n",**argv );
        }
        else
        {
            filename = *argv;
        }

    if (filename) fp = fopen( filename,"r" );
    if (!fp) { fprintf(stderr,"error: can't read file\n"); exit(1); }

    int i = parse_sexps( fp, parse_callback );
    fprintf( stderr,
	"%s: %d sexprs, %d objects read; %d of %d RSF tuples written\n",
	progname, i,nobjects, nout,nrsf );
}

    // Here be an s-expr parse callback function. The syntax of
    // NetworkObject s-exprs is implied by the code herein.

    static void parse_callback( char *s, int d, int i, int )
    {
	static char srcbuff[256], arcbuff[256];
        if (i) return;

        if (d==0) { nobjects++; strcpy( srcbuff,s ); }
        if (d==1) rsf_out("type",srcbuff,s );
        if (d==3) strcpy( arcbuff,s );
        if (d==4) rsf_out( arcbuff,srcbuff,s );

	// MJW syntactic variation for sequence attrs
        if (d==5) rsf_out( arcbuff,srcbuff,s );
    }

static void rsf_out( char *arc, char *src, char *dst )
{
    // HACK filter(s)
    // Use to remove unwanted types (classes), objects,
    // attr categories, etc.

    nrsf++;
/*
    if (!strncmp(dst,"Identifier_",11)) return;
    if (!strncmp(dst,"Function_",9)) return;
*/

/*
    if (!strcmp(arc,"refineName")) return;
    if (!strncmp(arc,"allRelevant",11)) return;
    if (!strcmp(arc,"analysis")) return;

    if (!strcmp(arc,"cRTupleResults")) return;
    if (!strcmp(arc,"dBTupleResults")) return;
    if (!strcmp(arc,"cRClusterResults")) return;
    if (!strcmp(arc,"dBClusterResults")) return;
*/

//    if (!strcmp(arc,"idName") || !strcmp(arc,"functionName"))
    {
	nout++;
        fprintf( ofp, format, arc, src, dst );
    }
}
