// $Author: jmartin $
// $Date: 1997-12-05 01:57:18 $
// $Source: /root/cvs/Rigi/rigiedit/UT/src/ut_telos.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

#ifndef UT_TELOS_H
#define UT_TELOS_H

// This file describes the Rigi side of the interface between
// Telos/mbus and Rigi. It is therefore seen by both the
// interface library (utlib), AND the core part of the rigiedit
// program itself (in ut.C). The latter sees this file via a
// symbolic link between the rigiedit source code directory, and
// the interface source code directory.

// We should try to keep this interface as small and confined as possible!

const int UT_ASK 	= 0;
const int UT_TELL 	= 1;
const int UT_START	= 2;
const int UT_END	= 3;
const int UT_UNTELL	= 4;

const int UT_FLUSH	= 8;

const int UT_TELOS	= 9;
const int UT_DEBUG	= 10;
const int UT_TIME	= 11;
const int UT_MAXOBJECTS	= 12;

const int UT_STOP	= 13;


// 1. TELL:	For communicating data in RSF form, to the server
// 2. COMMAND:	For communicating simple commands to interface and/or server
// 3. ASK:	For receiving info from the server, in RSF form

int UT_interface( int i, char *arc, char *src, char *dst );
int UT_interface( int i );
int UT_interface( int i, char*s, void(*)(char*,char*,char*) );

#endif

// ------------------------------------------------------------------------
//
// $Log: not supported by cvs2svn $
//   Revision 1.6  1995/10/29  20:02:01  mwhitney
//   removed archaic LOAD, SAVE and EMPTY
//
//   Revision 1.5  1995/10/16  17:26:35  mwhitney
//   added UT_STOP
//
//   Revision 1.4  1995/02/01  17:53:13  mwhitney
//   a few new KB server commands
//
//   Revision 1.3  1994/10/28  18:08:49  mwhitney
//   more stuff, incl pmdbflag
//
//   Revision 1.2  1994/08/26  16:06:07  mwhitney
//   Add UT_LOAD and UT_SAVE
//
//   Revision 1.1  1994/08/17  20:48:11  mwhitney
//   Initial revision
//
//
