// file:        os.H
// created by:  David Lauzon, University of Toronto
// date:        March 29, 1994.
// version:     0.0
// last update: March 29, 1994.



// This module is an interface to the operating system. It contains system
// dependent functions.
//
// getClientLogin() --> String*
//    The function getClientLogin returns the login name of the current client.
//
// getClientHostId() --> String*
//    The function getClientHostId returns the host id of the current client.
//
// getClientPId() --> String*
//    The function getClientPId returns the process id of the current client.
//
// getClientPNumber() --> int
//    The function getClientPNumber returns the host id (int) of the 
//    current client.
//
// getUniqueTimeString() --> String*
//    The function getUniqueTimeString returns a unique string of the form:
//                    seconds.microsecond
//    This is used to uniquely identify messages.


#include "error.H"

String* getClientLogin();
String* getClientHostId();
String* getClientPId();
int     getClientPNumber();
String* getUniqueTimeString();

