// $Author: jmartin $
// $Date: 2000-02-05 02:18:36 $
// $Source: /root/cvs/Rigi/rigiedit/adt/bytearray.C,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

// This may look like C code, but it is really -*- C++ -*-


#ifndef BYTEARRAYH
#include "bytearray.h"
#endif
void ByteArray::AllocSizeErr()
{
	cerr << "Unable to Allocate less then one Object  for each Array.\n";
	
}

void ByteArray::IndexRangeErr()
{
	cerr << "Tried to index element outside Array.\n";
	
}

ByteArray::ByteArray(unsigned int size)  {
	totalsize = size;
	if (totalsize<=0) 
		AllocSizeErr();
	else	{
    	series = new char[totalsize];
	}
	front = 0;
	back = 0;
}

ByteArray::ByteArray(const ByteArray& a) {
	totalsize = a.totalsize;
	series = new char[totalsize];
	front = 0;
	back = 0;
}
	
ByteArray::~ByteArray() {
//	cerr << "Deleting ByteArray.\n";
	delete[] series;
}

/*
 * Object Functions.
 */
void ByteArray::operator=(const ByteArray& a) {

	delete[] series; // we need some type of garbage collection here.
	totalsize = a.Length();
	series = new char[totalsize];
	register int i = totalsize;
	register char* vv = &series[0];
	register char* av = &a.series[a.front];
	while (i--) *vv++ = *av++; 
	front = 0;
	back = a.back - a.front;
}
	
/*
 * ByteArray Funtions
 */
void ByteArray::reSize(unsigned int size)
{
	if (size<=0) AllocSizeErr();
	char* nv = new char[size];

	register int i = (size<=totalsize)?size:totalsize;
        register int j = (size<=totalsize)?(0):(size - totalsize);

	register char* nvp = &nv[i];
	while(j--){
		*nvp++ = NULL;
	}

	register char* vp = &series[0];
	nvp = &nv[0];
	while (i--) {
		*nvp++ = *vp++;
	}

	delete[] series;
	series = nv;
	totalsize = size;
}

void  ByteArray::doubleSize(unsigned int req_size) {
	unsigned new_size = totalsize * 2;
	while(req_size > new_size) new_size = new_size * 2;
	reSize(new_size);
}

int  ByteArray::AddOn(void*  start, int lgth ) {
	register char* tmp = (char* ) start;
	register char* arr = series + back;
	register char* finish = arr + lgth;

	if(((unsigned)back + lgth) > totalsize) {
		doubleSize(back+lgth);
		arr = series + back;
		finish = arr + lgth;
	}

	for(;arr < finish;tmp++,arr++) {
		*arr = *tmp;
	}
	
		
	back += lgth;
	return lgth;
}

int  ByteArray::AddOn(int i) {
	register char* tmp = (char* ) &i;
	register char* arr = series + back;
	register char* finish = arr + sizeof(int);


	if((back + sizeof(int)) > totalsize) {
		doubleSize(back+sizeof(int));
		arr = series + back;
		finish = arr + sizeof(int);
	}
	for(;arr < finish;tmp++,arr++)
		*arr = *tmp;
		
	back += sizeof(int);
	return(sizeof(int));
}

int  ByteArray::AddOn(double i) {
	register char* tmp = (char* ) &i;
	register char* arr = series + back;
	register char* finish = arr + sizeof(double);

	if((back + sizeof(double)) > totalsize) {
		doubleSize(back+sizeof(double));
		arr = series + back;
		finish = arr + sizeof(double);
	}
	for(;arr < finish;tmp++,arr++)
		*arr = *tmp;
		
	back += sizeof(double);
	return(sizeof(double));
}

int  ByteArray::AddOn(CharType& i) {
	int lgth = i.Length();
	int total = AddOn(lgth); // first add on the length of the string.
	register char* tmp = i.string();
	register char* arr = series + back;
	register char* finish = arr + lgth;
	
	if(((unsigned)back + lgth) > totalsize) {
		doubleSize(back+lgth);
		arr = series + back;
		finish = arr + lgth;
	}
	for(;arr < finish;tmp++,arr++)
		*arr = *tmp;
		
	back += lgth;
	return(total + lgth); // sizeof(int) + length of string
}

int  ByteArray::AddOn(ByteArray& i) {
	int lgth = i.Length();
	int total = AddOn(lgth); // first add on the length of the array
	register char* tmp = i.series + i.front;
	register char* arr = series + back;
	register char* finish = arr + lgth;
	
	if(((unsigned)back + lgth) > totalsize) {
		doubleSize(back+lgth);
		arr = series + back;
		finish = arr + lgth;
	}
	for(;arr < finish;tmp++,arr++)
		*arr = *tmp;
		
	back += lgth;
	return(total + lgth);
}

int  ByteArray::OverLay(int offset,int i) {
	register int start = front + offset;
	start = (start < 0 ? 0 : start);
	register int nlgth = start + sizeof(int);
	register char* tmp = (char* ) &i;
	register char* arr = series + start;
	register char* finish = arr + sizeof(int);
	
	if((unsigned)nlgth > totalsize) {
		doubleSize(nlgth);
		arr = series + start;
		finish = arr + sizeof(int);
	}
	for(;arr < finish;tmp++,arr++)
		*arr = *tmp;
		
	front = (front > start ? start : front);
	start = (nlgth-back > 0 ? nlgth-back : 0); // overlap
	back = (back > nlgth ? back : nlgth);
	return(start);
}

int  ByteArray::OverLay(int offset, ByteArray& ba) {
	register int start = front + offset;
	start = (start < 0 ? 0 : start);
	register int lgth = ba.Length();
	register int nlgth = start + lgth;
	register char* tmp = (char*) ba.ByteRemove(lgth);
	register char* arr = series + start;
	register char* finish = arr + lgth;

	if((unsigned)nlgth > totalsize) {
		doubleSize(nlgth);
		arr = series + start;
		finish = arr + lgth;
	}
	for(;arr < finish;tmp++,arr++) {
		*arr = *tmp;
	}
	
	front = (front > start ? start : front);
	start = (nlgth-back > 0 ? nlgth-back : 0); // overlap 
	back = (back > nlgth ? back : nlgth);
	return(start);

}
	

void ByteArray::RemovePtr(void* start, int lgth) {
	register char* tmp = (char*) start;
	register char* arr = series + front;
	register char* finish = arr + lgth;

	if(finish > (series + totalsize)) {
		IndexRangeErr();
		return;
	}
	for(;arr < finish;tmp++,arr++)
		*tmp = *arr;
	front += lgth;

	Reset();
}

void ByteArray::RemoveInt(int& i) {
	int result;
	register char* tmp = (char*) &result;
	register char* arr = series + front;
	register char* finish = arr + sizeof(int);

	if(finish > (series + totalsize)) {
		IndexRangeErr();
		return;
	}
	for(;arr < finish;tmp++,arr++)
		*tmp = *arr;

	front += sizeof(int);
	Reset();

	i = result;
}

void ByteArray::RemoveUInt(unsigned int& i) {
	unsigned int result;
	register char* tmp = (char*) &result;
	register char* arr = series + front;
	register char* finish = arr + sizeof(unsigned int);

	if(finish > (series + totalsize)) {
		IndexRangeErr();
		return;
	}
	for(;arr < finish;tmp++,arr++)
		*tmp = *arr;

	front += sizeof(unsigned int);
	Reset();

	i = result;
}

void ByteArray::RemoveDouble(double& i) {
	double result;
	register char* tmp = (char*) &result;
	register char* arr = series + front;
	register char* finish = arr + sizeof(double);
	
	if(finish > (series + totalsize)) {
		IndexRangeErr();
		return;
	}
	for(;arr < finish;tmp++,arr++)
		*tmp = *arr;
	front += sizeof(double);
	Reset();

	i = result;
}

void ByteArray::RemoveCharType(CharType& i) {
	int lgth;
	RemoveInt(lgth);
	char* result = new char[lgth + 1];
	register char* tmp = result;
	register char* arr = series + front;
	register char* finish = arr + lgth;
	
	if(finish > (series + totalsize)) {
		IndexRangeErr();
		return;
	}
	for(;arr < finish;tmp++,arr++)
		*tmp = *arr;
	*tmp = '\0';
	front += lgth;
	Reset();

	i.SetString(result);
}

void ByteArray::RemoveByteArray(ByteArray& i) {
	int lgth;
	RemoveInt(lgth);
	if(lgth + i.Length() > i.Size()) {
		i.reSize(lgth + i.Length());
	}

	register char* tmp = i.series + i.back;
	register char* arr = series + front;
	register char* finish = arr + lgth;
	
	if(finish > (series + totalsize)) {
		IndexRangeErr();
		return;
	}
	for(;arr < finish;tmp++,arr++)
		*tmp = *arr;

	front += lgth;
	i.back += lgth;

	Reset();
}

void* ByteArray::ByteRemove(int lgth) {
	int start = front;
	if(((unsigned)front + lgth) > totalsize) {
		doubleSize(front+lgth);
	}
	front += lgth;
	return ((void*) (series + start));
}

void* ByteArray::ByteAddOn(int lgth) {
	int start = back;
	if(((unsigned)back + lgth) > totalsize) {
		doubleSize(back+lgth);
	}
	back += lgth;

	return ((void*)(series + start));
}

void ByteArray::Dump(char* tmp) {
	int i;
	char* sr = series + front;

	for(i = front;i < back;i++) *tmp++ = *sr++;
}



// ------------------------------------------------------------------------
//
// $Log: not supported by cvs2svn $
// Revision 1.3  1995/11/24 18:53:19  jmcdanie
// signed/unsigned comapres
//
//   Revision 1.2  1995/06/12  22:06:09  jmcdanie
//   PC port
//
//   Revision 1.1  1994/06/30  20:09:04  bcorrie
//   Initial revision
//
//

