// $Author: jmcdanie $
// $Date: 1995-06-12 22:23:59 $
// $Source: /root/cvs/Rigi/rigiedit/adt/bytearray.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

// This may look like C code, but it is really -*- C++ -*-

#ifndef BYTEARRAYH
#define BYTEARRAYH
#ifndef OBJECTH
#include "object.h"
#endif
#ifndef CHARTYPEH
#include "chartype.h"
#endif

const unsigned int BYTE_DEFAULT_CAPACITY = 128;

class ByteArray :  private RigiObject {
	char*		series;
	unsigned int	totalsize;
	int		front;
	int		back;
	void		AllocSizeErr();
	void		IndexRangeErr();
	
    public:
	// Routines to initialize and destroy the class.
	ByteArray(unsigned int size = BYTE_DEFAULT_CAPACITY);
	ByteArray(const ByteArray&);
	~ByteArray(); 
	
	// Functions that are Required to Use this Class as an Object
	
	virtual	int Printout(int) const 
	  {return 0;}
	virtual unsigned int Hash() const 
	  {return 0;}        

	virtual void operator=(const ByteArray&);
	//virtual RigiBool operator==(const ByteArray&) const;
	//virtual RigiBool isEqual(void* a) const;
	//virtual void* Create(); 
	//virtual void* Duplicate(); 
	//virtual void Delete_type(ObjectPtr) {}
	
	// Routines specific to this class
	
   	void reSize(unsigned int);
   	void doubleSize(unsigned int);
	unsigned Size() 
	  {return totalsize;}
	unsigned Length() const
	  {return ((unsigned) back - front);}

   	int AddOn(void*, int);
	int AddOn(int);
	int AddOn(double);
	int AddOn(CharType&);
        int AddOn(ByteArray&);

	int OverLay(int,int);
	int OverLay(int,ByteArray&);

	void RemovePtr(void*, int);
	void RemoveInt(int&);
	void RemoveUInt(unsigned int&);
	void RemoveDouble(double&);
	void RemoveCharType(CharType&);
	void RemoveByteArray(ByteArray&);

	void Reset() 
	  {if(front == back) front = back = 0;}
	void Clear() 
	  {front = back = 0;}
	
	void*	ByteRemove(int);
	void*	ByteAddOn(int);
	int	Front() 
	  {return front;}
	int	Back()  
	  {return back;}
	void    Dump(char*);
};
	
#endif

// ------------------------------------------------------------------------
//
// $Log: not supported by cvs2svn $
//   Revision 1.2  1994/06/30  17:40:45  bcorrie
//   Fixed up RCS header stuff
//
//

