// $Author: jmcdanie $
// $Date: 1995-06-12 22:06:10 $
// $Source: /root/cvs/Rigi/rigiedit/adt/chararray.C,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

#ifndef CHARARRAYH
#include "chararray.h"
#endif

CharArray::CharArray(unsigned int size) : Array (size) {
	slot = 0;
}

CharArray::CharArray(const CharArray& a) : Array (a.size())
{
	slot = 0;
}

CharArray::~CharArray() {
//	cerr << "Deleting CharArray.\n";
}

void  CharArray::Create(char* new_name) {
//	fprintf(stderr,"Adding CharType to CharType List.\n");
	CharTypePtr tmp = new CharType(new_name);

 	Array::Add(slot++,(ObjectPtr)tmp);
}

void  CharArray::Create(char* new_name,int lgth) {
//	fprintf(stderr,"Adding CharType to CharType List.\n");
	CharTypePtr tmp = new CharType(new_name,lgth);

 	Array::Add(slot++,(ObjectPtr)tmp);
}

void  CharArray::Create(int i, char* new_name) {
//      fprintf(stderr,"Adding CharType to CharType List.\n");
        CharTypePtr tmp = new CharType();
        tmp->Assign(new_name);

        Array::Add(i,(ObjectPtr)tmp);
}

void  CharArray::Add(char* new_name) {
//	fprintf(stderr,"Adding CharType to CharType List.\n");
	CharTypePtr tmp = new CharType;
 	tmp->Assign(new_name);

 	Array::Add(slot++,(ObjectPtr)tmp);
}


void  CharArray::Add(CharType& new_name) {
//	fprintf(stderr,"Adding CharType to CharType List.\n");
 	Array::Add(slot++,(ObjectPtr) &new_name);
}

void  CharArray::Append(char* new_name) {
//	fprintf(stderr,"Adding CharType to CharType List.\n");
 	int tmp = slot - 1;
 	if(tmp >= 0)
		((CharTypePtr)Array::At(tmp))->Append(new_name);
}

int CharArray::FindIndex(char* str)
{
    CharType searchstr(str);
    return Array::FindIndex((ObjectPtr)(&searchstr));
}

char* 	CharArray::Concat(char sep)
{
	int total_size = 0;
	int i;
	char *ptr;
	char *tmp;


	for(i = 0; i < slot; i++)
		total_size += ((CharTypePtr)Array::At(i))->Length();

	if(slot > 0 && sep != 0) total_size += slot - 1;

	if(total_size == 0) 
		return NULL;
	else
//		fprintf(stderr,"Concating %d elements together.\n");

	tmp = ptr = new char[total_size + 1];
	if(sep != 0) {
		for(i = 0; i < slot; i++) {
			strcpy(ptr,((CharTypePtr)Array::At(i))->string());
			ptr += ((CharTypePtr)Array::At(i))->Length();
			*ptr = sep;
			ptr++;
		} 
		*(--ptr) = '\0';

	}
	else {
		for(i = 0; i < slot; i++) {
			strcpy(ptr,((CharTypePtr)Array::At(i))->string());
			ptr += ((CharTypePtr)Array::At(i))->Length();
		} 
		*(ptr) = '\0';

	}
	

	return tmp;
}

void CharArray::Empty() 
{

	Array::Empty();
	slot = 0;
}

RigiBool CharArray::operator==(const CharArray& a) const {
//	fprintf(stderr,"CharArray Operator== \n");
	return ((RigiBool)(Array::operator==(*((ArrayPtr)&a))));
}	

void CharArray::operator=(const CharArray& a) {
//	fprintf(stderr,"CharArray Operator= \n");	
	Array::operator=(*((ArrayPtr)&a));
}

char* CharArray::Peek()
{
	int i = slot - 1;
	return (((CharTypePtr)Array::At(i))->string());
}

char* CharArray::At(int i)
{
	return (((CharTypePtr)Array::At(i))->string());
}


// ------------------------------------------------------------------------
//
// $Log: not supported by cvs2svn $
//   Revision 1.2  1994/10/25  18:37:28  bcorrie
//   Added a Create method to the class and changed a SetString to an Assign
//
//   Revision 1.1  1994/06/30  20:09:04  bcorrie
//   Initial revision
//
//

