// $Author: jmartin $
// $Date: 2000-02-05 02:18:36 $
// $Source: /root/cvs/Rigi/rigiedit/adt/chartype.C,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

#define FDEBUG
#ifndef DEBUGTYPEH
#include "ccdebug.h"
#endif
#ifndef CHARTYPEH
#include "chartype.h"
#endif

CharType::CharType() {
	//DebugOn();
	MsgDebug("Creating empty CharType",CharType::CharType);
	//DebugOff();
	name = NULL;
}

CharType::CharType(char* new_name) {
	name = NULL;
 	if(new_name == NULL) return;
	name = new char[strlen(new_name) + 1];
	strcpy(name,new_name);
	//DebugOn();
	ValueDebug("Creating CharType(char*) ",name,CharType::CharType);
	//DebugOff();
}

CharType::CharType(char* new_name,int lgth) {
	name = NULL;
 	if(new_name == NULL) return;
	name = new char[lgth + 1];
	strncpy(name,new_name,lgth);
	*(name+lgth) = '\0';
	//DebugOn();
	ValueDebug("Creating CharType(char*,int) ",name,CharType::CharType);
	//DebugOff();
}

CharType::CharType(double num) {
	name = NULL;
	char new_name[20];
	sprintf(new_name,"%f",num);
	name = new char[strlen(new_name) + 1];
	strcpy(name,new_name);
	//DebugOn();
	ValueDebug("Creating CharType(double)",name,CharType::CharType);
	//DebugOff();
}

CharType::CharType(CharTypePtr oldchar) {
	name = NULL;
	name = new char[strlen(oldchar->name) + 1];
	strcpy(name,oldchar->name);
	//DebugOn();
	ValueDebug("Creating CharType(CharTypePtr) ",name,CharType::CharType);
	//DebugOff();
}

CharType::CharType(CharType& oldchar)
{
	name = NULL;
	name = new char[strlen(oldchar.name) + 1];
	strcpy(name,oldchar.name);
	//DebugOn();
	ValueDebug("Creating CharType(CharTypePtr) ",name,CharType::CharType);
	//DebugOff();
}

CharType::~CharType() {
	//DebugOn();
	ValueDebug("Deleting CharType ",name,CharType::~CharType);
	ValueDebug("Address of name = ",(int)(name),CharType::~CharType);
	if(name != NULL)
	{
		//DebugOn();
		ValueDebug("Deleting the string ",name,CharType::~CharType);
		//DebugOff();
		delete[] name;
		name = NULL;
	}
	//DebugOff();
}

void CharType::Assign(const char* new_name)
{
    // If the new name is NULL, do nothing

	if (new_name == NULL) return;

    // Keep track of the name pointer so we can delete later

    char* tmpname = name;

    //DebugOn();
	ValueDebug("old name = ",name,CharType::Assign);
	ValueDebug("Address of old name = ",(int)(name),CharType::Assign);

    // Create a new string and copy the given string to our
    // instance variable. If our memory allocation fails, we
    // don't change the CharType

	name = new char[strlen(new_name) + 1];
    if (name == NULL)
    {
        fprintf(stderr,"Out of memory in CharType::Assign\n");
        name = tmpname;
        return;
    }
	strcpy(name,new_name);

    // If the old string is not NULL (that is, if it existed previously)
    // delete it.

	if(tmpname != NULL)
	{
		ValueDebug("Deleting CharType ",tmpname,CharType::Assign);
		//DebugOff();
        tmpname[0] = '\0';
		delete[] tmpname;
	}
	ValueDebug("new name = ",name,CharType::Assign);
	ValueDebug("Address of new name = ",(int)(name),CharType::Assign1);
	ValueDebug("Address of new_name = ",(int)(new_name),CharType::Assign);
        //DebugOff();
}

void CharType::Assign(char* new_name, int length) {
	//DebugOn();
	ValueDebug("Assigning CharType(char*,int) ",name,CharType::Assign);
	//DebugOff();

    // If the name given is NULL, do nothing

	if(new_name == NULL) return;

    // Keep track of the name pointer so we can delete later

    char* tmpname = name;

    // Create the new string and copy the given string to the new one

	name = new char[length + 1];
    if (name == NULL)
    {
        fprintf(stderr,"Out of memory in CharType::Assign(char*,int)\n");
        name = tmpname;
        return;
    }
	strncpy(name,new_name,length);
	*(name+length) = '\0';

    // Delete the old name if it exists

	if(tmpname != NULL)
	{
		//DebugOn();
		ValueDebug("Deleting CharType ",name,CharType::Assign2);
		//DebugOff();
        tmpname[0] = '\0';
		delete[] tmpname;
	}

}

double CharType::Double() {
	//DebugOn();
	ValueDebug("Returning double of ",name,CharType::Double);
	//DebugOff();
	double tmp;
	sscanf(name,"%ld",&tmp);
	return tmp;
}

void CharType::Append(const char* new_name) {

	char* new_string;
	int new_lgth,old_lgth;
	
	//DebugOn();
	ValueDebug("Appending ",new_name,CharType::Append);
	//DebugOff();

	if(new_name == NULL) 
		return;
	if ((new_lgth = strlen(new_name)) == 0)
		return;

	if(name != NULL) {
		old_lgth = strlen(name);
		new_string = new char[old_lgth + new_lgth + 1];
	}
	else {			   
		name = new char[strlen(new_name) + 1];
		strcpy(name,new_name);
		return; 
	}
	strcpy(new_string,name);
	//DebugOn();
	ValueDebug("Deleting CharType ",name,CharType::Assign2);
	//DebugOff();
	delete[] name;
	name = new_string;
	new_string += old_lgth;
	strcpy(new_string,new_name);
	
}

RigiBool CharType::operator==(const CharType& a) const {
//	fprintf(stderr,"Checking to see if this Object is equal to another.\n");
	//DebugOn();
	MsgDebug("Checking equality",CharType::==);
	//DebugOff();
	if((a.name == NULL) || (name == NULL))
		return RigiFalse;
	else {
		return((RigiBool)((this == &a) || (!strcmp(a.name,name))));
	}
}	

void CharType::operator=(const CharType& a) {
	//DebugOn();
	MsgDebug("Assignment",CharType::=);
	//DebugOff();

    // Check for an empty CharType

    if (a.name == NULL) {
       if (name != NULL) delete[] name;
        name = NULL;
        return;
    }

    // Allocate a new string and copy, then delete the old one if it
    // exists.

    char* tmpname = name;
	name = new char[strlen(a.name)+1];
	strcpy(name,a.name);
	if(tmpname != NULL)
	{
		//DebugOn();
		ValueDebug("Deleting CharType ",name,CharType::Assign2);
		//DebugOff();
        tmpname[0] = '\0';
		delete[] tmpname;
	}
}
 
int CharType::Printout(int a) const {
	//DebugOn();
	MsgDebug("Printout",CharType::Printout);
	//DebugOff();
	if(name != NULL) {
		fprintf(stderr,"%s ",name);
		return(a + strlen(name) + 1); 
	}
	else 
		return(a);
}

unsigned int CharType::Hash() const {
	register unsigned int h;
	register char *s = name;
	if(s == NULL || *s == 0) return 0;	// NULL or empty string
	h = ((int)*s++) << 1;
//	h = ((int)*s) << 1;
	while(*s++) h^=(((int)*s) & 0xff);
	
	return h;
	
}


RigiBool CharType::isEqual(void* a) const {
	return ((RigiBool)(*this==*(CharTypePtr)a));
}


void* CharType::Duplicate() 
{
	CharTypePtr tmp = new CharType();
 	*tmp = *this;
	return((void*) tmp);
}

void CharType::Delete_type(ObjectPtr a) {
 	delete ((CharTypePtr) a);
}




// ------------------------------------------------------------------------
//
// $Log: not supported by cvs2svn $
// Revision 1.3  1995/06/12 22:06:11  jmcdanie
// PC port
//
//   Revision 1.2  1994/10/06  17:51:18  bcorrie
//   Fixed a delete bug in the case when we do assign of a CharType to
//   another CharType.
//
//   Revision 1.1  1994/06/30  20:09:06  bcorrie
//   Initial revision
//
//

