// $Author: jmcdanie $
// $Date: 1995-06-12 22:24:01 $
// $Source: /root/cvs/Rigi/rigiedit/adt/collection.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

// This may look like C code, but it is really -*- C++ -*-

#ifndef COLLECTIONH
#define COLLECTIONH 1

#ifndef OBJECTH
#include "object.h"
#endif

const unsigned int CLTN_DEFAULT_CAPACITY	= 8;
const unsigned int CLTN_EXPANSION_INCREMENT = 16;	
const unsigned int CLTN_EXPANSION_FACTOR = 2;	

struct CltnPos {
	int	index;	// used by most Collections 
	void*	ptr;	// used by LinkedLists 
	unsigned int num;	// used by Bags 
	CltnPos()	{ index = num = 0; ptr = 0; }
};

#define IterDO(cltn,class_def,arg)         			\
{							\
	register class_def arg;				\
	CltnPos DO_pos; 				\
	while (arg = (class_def)((cltn).doNext(DO_pos))) {
#define ODretI }}

class Collection;
typedef Collection* CollectionPtr;

#define Colerr(a) cerr << \
"ERROR :: Generic Collection Routine Called :: " << \
"a" << "\n"

class Collection  : private RigiObject  {	// abstract class 
    protected:
    public:
	Collection() {}
	~Collection() {}
	
	// Routines that are required by RigiObjects and derived classes of RigiObjects
 	virtual int Printout(int) const;
	virtual unsigned int Hash() const;
	virtual RigiBool isEqual(void*) const;
	virtual void* Create_class();
	virtual void* Duplicate_class();
	virtual void Delete_class(ObjectPtr);
	
	
	// Routines that are required by Collections and derived classes of
	// Collections
  	virtual ObjectPtr 	doNext(CltnPos&) const /* MJW: undo KW 930924 */
	{Colerr(doNext); return NIL;}
	virtual ObjectPtr	doFirst(CltnPos&)
	{Colerr(dofirst); return NIL;}
  	virtual ObjectPtr	doPrev(CltnPos&) 
	{Colerr(doPrev); return NIL;}
	virtual ObjectPtr	doLast(CltnPos&)
	{Colerr(doLast); return NIL;}
	
	
	virtual RigiBool IsNil(const CltnPos&) 
	{Colerr(IsNil); return (RigiBool) RigiFalse;}
	virtual ObjectPtr Next(CltnPos&) 
	{Colerr(Next); return NIL;}
	virtual ObjectPtr Prev(CltnPos&) 
	{Colerr(Prev); return NIL;}
	virtual RigiBool NotEnd(const CltnPos&)
	{Colerr(NotEnd); return (RigiBool) RigiFalse;}
	virtual void SetElem(const CltnPos&,ObjectPtr)
	{Colerr(SetElem); }
	virtual ObjectPtr Elem(const CltnPos&) 
	{Colerr(Elem); return NIL;}
	virtual CltnPos	SetPos(CltnPos& a, int i) 
	{Colerr(SetPos); i = 0; return a;}
	
  	virtual void reSize(unsigned int) {Colerr(reSize);}
   	virtual unsigned int Size() const {Colerr(size);  return 0;}
  	virtual unsigned int Capacity() const {Colerr(capacity);  return 0;}
	
};

#endif

// ------------------------------------------------------------------------
//
// $Log: not supported by cvs2svn $
//   Revision 1.2  1994/06/30  17:40:54  bcorrie
//   Fixed up RCS header stuff
//
//

