// $Author: jmcdanie $
// $Date: 1995-11-24 18:56:02 $
// $Source: /root/cvs/Rigi/rigiedit/adt/numarray.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

// This may look like C code, but it is really -*- C++ -*-

#ifndef NUMARRAYH
#define NUMARRAYH

#ifndef ARRAYOBIDH
#include "array.h"
#endif
#ifndef NUMTYPEH
#include "numtype.h"
#endif

class NumArray;
typedef NumArray* NumArrayPtr;

class NumArray : public Array {
	int	slot;
    public:
   // Routines to initialize and destroy the class.
	NumArray(unsigned int size = CLTN_DEFAULT_CAPACITY);
	NumArray(const NumArray&);
	~NumArray(); 

    // Functions that are Required to Use this Class as an Object

   		// .... all routines the same as in Class Array.......

   // Routines that are required by a Collection class and derived classes
   // of Collections. [See Array Class for these routines.]

   	virtual unsigned int size() const {return slot;}
	   
   		// .... all routines the same as in Class Array.......

   // Routines specific to this class
  	void operator=(const NumArray&);
  	RigiBool operator==(const NumArray&) const;
	void Create(unsigned);
	void Add(NumType&);
	unsigned Remove() 
	    /*this causes a memory leak because the caller
	      cannot possibly delete the allocated memory
	      without a pointer to it.  JGM **BUG**
	    */
	    {return ((NumTypePtr)((void*)Array::Remove(--slot)))->Value();}
	ObjectPtr Pop()
	    {return (Array::Remove(--slot));}
	ObjectPtr Look(int i)
	    {return (Array::At(i));}
	void Empty();
	virtual unsigned int Size() const
	    {return slot;}
	unsigned Peek();
	unsigned At(int);
	
};
	
#endif

// ------------------------------------------------------------------------
//
// $Log: not supported by cvs2svn $
//   Revision 1.3  1995/06/12  22:24:04  jmcdanie
//   PC port
//
//   Revision 1.2  1994/06/30  17:40:58  bcorrie
//   Fixed up RCS header stuff
//
//
