// $Author: jmartin $
// $Date: 1996-10-19 18:58:51 $
// $Source: /root/cvs/Rigi/rigiedit/adt/numlist.C,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

// This may look like C code, but it is really -*- C++ -*-

#ifndef NUMLISTH
#include "numlist.h"
#endif

NumList::NumList(unsigned int size) : HashTbl (size) {
//	MsgDebug("Created Numlist.",NumList::NumList);
}

NumList::~NumList() {
}

NumTypePtr NumList::Create(unsigned value) {
    
    NumTypePtr tmp = new NumType(value);
    ObjectPtr  tmp2;
    
    if((tmp2 = HashTbl::Add((ObjectPtr) tmp)) == NIL) {
	return tmp;
    }
    else {
        delete tmp;
        NumTypePtr GCCHACK = (NumTypePtr) tmp2;
        return(GCCHACK);
    }

}

RigiBool NumList::Add(NumTypePtr ob) {
	ObjectPtr tmp;
	if(ob == NIL) {
		return(RigiFalse);
	}
	
	if((tmp = HashTbl::Add((ObjectPtr) ob)) == NIL) {
		return RigiTrue;   // successfull add.
	}
	else {
		return RigiFalse;   // already was present.
	}
	
}

RigiBool NumList::Includes(unsigned value) {
 	NumType ob(value);
	if(HashTbl::Find((ObjectPtr) &ob) == NIL) {
		return(RigiFalse);
	}
 	else {
		return(RigiTrue);
	}

}

RigiBool NumList::Remove(unsigned int value,unsigned int& result) {
 	NumType ob(value);
	NumTypePtr tmp;

	tmp = (NumTypePtr) HashTbl::Remove((ObjectPtr) &ob);
	if(tmp != NIL) {
		/*this causes a memory leak because the caller
		  cannot possibly delete the allocated memory
		  without a pointer to it.  JGM **BUG**
		*/
		result = tmp->Value();
		return(RigiTrue); 
	}
	else {
		return(RigiFalse);
	}
	
}

RigiBool NumList::operator==(const NumList& a) {
	return ((RigiBool)(HashTbl::operator==(*((HashTblPtr)&a))));
}	

void NumList::operator=(const NumList& a) {
	HashTbl::operator=(*((HashTblPtr)&a));
}  
 
void NumList::operator&(const NumList& a) {
	HashTbl::operator&(*((HashTblPtr)&a));
}	

void NumList::operator|(const NumList& a) {
	HashTbl::operator|(*((HashTblPtr)&a));
}	

void NumList::operator-(const NumList& a) {
	HashTbl::operator-(*((HashTblPtr)&a));
}	









// ------------------------------------------------------------------------
//
// $Log: not supported by cvs2svn $
//   Revision 1.2  1995/06/12  22:06:13  jmcdanie
//   PC port
//
//   Revision 1.1  1994/06/30  20:09:11  bcorrie
//   Initial revision
//
//
