// $Author: jmartin $
// $Date: 1996-10-19 18:58:51 $
// $Source: /root/cvs/Rigi/rigiedit/adt/tokenlist.C,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

// This may look like C code, but it is really -*- C++ -*-
#define FDEBUG
#ifndef DEBUGTYPEH
#include "ccdebug.h"
#endif

#ifndef TOKENLISTH
#include "tokenlist.h"
#endif

TokenList::TokenList(unsigned int size) : HashTbl (size) {
    MsgDebug("Created Tokenlist.",TokenList::TokenList);
}

TokenList::~TokenList() {
    MsgDebug("Deleting TokenList.",TokenList::TokenList);;
}

RigiBool TokenList::Add(TokenType& ob) {
    
    if(HashTbl::Add((ObjectPtr) &ob) == NULL) {
		return RigiTrue;   // successfull add.
    }
    else {
		return RigiFalse;   // already was present.
    }
}

void TokenList::Create(char* new_name,int i) {
    MsgDebug("Adding Token to Token List.",TokenList::Create);
    if(new_name == NULL) {
		MsgDebug("NULL name received.",TokenList::Create);
		return;
    }
    
    TokenTypePtr tmp = new TokenType(new_name,i);
    
    if(HashTbl::Add((ObjectPtr) tmp) != NULL) {
		delete tmp;
    }
}

void TokenList::Create(char* new_name,int i,char* type_name)
{
    MsgDebug("Adding Token to Token List.",TokenList::Create);
    if(new_name == NULL || type_name == NULL)
    {
		MsgDebug("NULL name received.",TokenList::Create);
		return;
    }
    
    TokenTypePtr tmp = new TokenType(new_name,i);
    tmp->SetTypeName(type_name);
    
    if(HashTbl::Add((ObjectPtr)tmp) != NULL)
    {
		delete tmp;
    }
}

void TokenList::Remove(char* new_name) {
    TokenTypePtr tmp2;

    if(new_name == NULL) {
		MsgDebug("NULL name received.",TokenList::Remove);
		return;
    }
    TokenTypePtr tmp = new TokenType(new_name,0);
    
    tmp2 = (TokenTypePtr) HashTbl::Remove((ObjectPtr) tmp);
    delete tmp;
    if (tmp2 != NULL) delete tmp2;
}

TokenTypePtr TokenList::Find(TokenType& search_token) {
    ObjectPtr tmp = HashTbl::Find((ObjectPtr) &search_token);
    if(tmp == NULL) {
		ValueDebug("Did not Find ",search_token.Name(),TokenList::Find);
    }
    TokenTypePtr GCCHACK = (TokenTypePtr) tmp;
    return(GCCHACK);
}


RigiBool TokenList::operator==(const TokenList& a) {
    MsgDebug("Checking, is this tokenlist equal another.",TokenList::op==);
    return (HashTbl::operator==(*((HashTblPtr)&a)));
}	

void TokenList::operator=(const TokenList& a) {
    MsgDebug("Setting this tokenlist to equal another.",TokenList::op=);
    HashTbl::operator=(*((HashTblPtr)&a));
}  
 
void TokenList::operator&(const TokenList& a) {
    HashTbl::operator&(*((HashTblPtr)&a));
}	





















// ------------------------------------------------------------------------
//
// $Log: not supported by cvs2svn $
//   Revision 1.2  1995/06/12  22:06:16  jmcdanie
//   PC port
//
//   Revision 1.1  1994/06/30  20:09:15  bcorrie
//   Initial revision
//
//

