// $Author: jmartin $
// $Date: 1996-10-19 18:58:51 $
// $Source: /root/cvs/Rigi/rigiedit/adt/tokentype.C,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

#define FDEBUG
#ifndef DEBUGTYPEH
#include "ccdebug.h"
#endif

#ifndef TOKENTYPEH
#include "tokentype.h"
#endif

TokenType::TokenType()
{
    name.Assign("");
    typeName.Assign("");
    index = 0;
}

TokenType::TokenType(char* new_name, int i)
{
    name.Assign(new_name);
    index = i;
    typeName.Assign("");
}

TokenType::TokenType(char* new_name)
{
    name.Assign(new_name);
    index = 0;
    typeName.Assign("");
}

TokenType::TokenType(TokenType& oldtoken)
{
    name.Assign(oldtoken.Name());
    typeName.Assign(oldtoken.TypeName());
    index = oldtoken.Index();
}

TokenType::~TokenType()
{
}

void TokenType::SetName(char* a)
{
    name.Assign(a);
}

void TokenType::SetTypeName(char* str)
{
    typeName.Assign(str);
}

void TokenType::SetIndex(int i)
{
    index = i;
}

char* TokenType::Name() const
{
    return name.string();
}

char* TokenType::TypeName() const
{
    return typeName.string();
}

int TokenType::Index() const
{
    return index;
}

void TokenType::Assign(char* new_name, int i)
{
    name.Assign(new_name);
    index = i;
    typeName.Assign("");
}

RigiBool TokenType::operator==(const TokenType& a) const
{
    MsgDebug("Checking equality.",TokenType::operator==);	
    if((a.Name() == NIL) || (Name() == NIL)) return RigiFalse;
    else return((RigiBool)(!(strcmp(a.Name(),Name()))));
}	

void TokenType::operator=(const TokenType& a)
{
    name.Assign(a.Name());
    index = a.index;
    typeName.Assign(a.TypeName());
}
 
int TokenType::Printout(int a) const
{
    if(name.string() != NULL)
    {
		fprintf(stderr,"%s ",name.string());
		return(a + strlen(name.string()) + 1);
    }
    else
    {
		fprintf(stderr,"(NULL) ");
		return(a); 
    }
}

unsigned int TokenType::Hash() const
{
    return name.Hash();
}


RigiBool TokenType::isEqual(void* a) const 
{
    return *this==*(TokenTypePtr)a;
}




// ------------------------------------------------------------------------
//
// $Log: not supported by cvs2svn $
//   Revision 1.2  1995/06/12  22:06:16  jmcdanie
//   PC port
//
//   Revision 1.1  1994/06/30  20:09:15  bcorrie
//   Initial revision
//
//

