/* RigiEdit for MS Windows
        Dr. H. A. Mller,
        University of Victoria,
        Victoria, BC
    Written by
        G.Kacy, February, 1996
*/

#ifndef CFGDATA_H_
#define CFGDATA_H_

//
// NOTE: ANY CHANGES TO FOLLOWING ARRAY SHOULD BE REFLECTED IN CFGENV.RCL
// RIGIEDIT CONFIGURATION WIDGET

// default values for the environment variables
typedef struct FieldArray_t {
    char *tag;
    char *val;
} FieldArray;

static const FieldArray fldArr[] = {
    {"RIGI",            ""},
#if defined (__WINDOWS__) || defined (__OS2__)
    {"RIGIUSER",        "."},
#else
    {"RIGIUSER",        "~"},
#endif
    {"RIGIINIT",        "$RIGI/Rigi/domain"},
    {"RIGIDOMAIN",      "c"},
    {"RIGILIB",         "$RIGI/Rigi"},
    {"ICONDIR",         "$RIGI/Rigi/icons"},
    {"SRCDIR",          "$RIGI/Rigi/icons"},
    {"RIGIRCL",         "$RIGI/Rigi/rcl/rc.rcl"},
    {"RIGIURCL",        ""},
    {"RIGISTY",         "$RIGI/Rigi/rcl/sty/rigi.rcl"},
    {"RIGIUSTY",        ""},
    {"DBDIR",           "$RIGI/Rigi/db"},
    {"DBREFDIR",        "$RIGI/Rigi/db"},
    {"RIGIBIN",         "$RIGI/bin"},
#if defined (__WINDOWS__) || defined (__OS2__) || defined(__WIN32__)
    {"TMPDIR",          "$RIGI/Rigi/tmp"},
#else
    {"TMPDIR",          "/tmp"},
#endif
    {"RIGIDBPORT",      "0"},
    {"RIGIDBHOST",      ""},
    {"RIGITITLE",       "Rigi Visual Editor - RigiEdit"},
#if defined (__WINDOWS__) || defined(__WIN32__)
    {"TEXTEDITOR",      "notepad.exe"},
#elif defined (__OS2__)
    {"TEXTEDITOR",      "e.exe"},
#else
    {"TEXTEDITOR",      "xterm -e vi +%d"},
#endif
    {"WEBROOT",         "http://"},
    {"WEBBROWSER",      "netscape -remote openURL(%s)"},
    {"ROOTLOCATION",    "0 185"},
    {"ROOTFRAMEDIM",    "529 456"},
    {"ROOTWINDOWDIM",   "500 400"},
    {"MAXCANVASDIM",    "2048 2048"},
    {"NUMBACKSTORES",   "2"},
    {"GRAPHFONT",       "-*-helvetica-medium-r-normal--*-100-*-*-*-*-*-*"},
    {"WORKBENCHFONT",   "-*-helvetica-bold-r-normal--*-120-*-*-*-*-*-*"},
    {"DEMOFONT",        "-*-helvetica-bold-r-normal--*-120-*-*-*-*-*-*"},
    {"MESSAGEFONT",     "-*-helvetica-bold-r-normal--*-120-*-*-*-*-*-*"},
    {"TEXTFONT",        "-*-courier-medium-r-normal--*-100-*-*-*-*-*-*"},
    {"CANVASCOLOR",     ""}
};

const int CFG_RIGI              = 0;
const int CFG_RIGIUSER          = 1;
const int CFG_RIGIINIT          = 2;
const int CFG_RIGIDOMAIN        = 3;
const int CFG_RIGILIB           = 4;
const int CFG_ICONDIR           = 5;
const int CFG_SRCDIR            = 6;
const int CFG_RIGIRCL           = 7;
const int CFG_RIGIURCL          = 8;
const int CFG_RIGISTY           = 9;
const int CFG_RIGIUSTY          = 10;
const int CFG_DBDIR             = 11;
const int CFG_DBREFDIR          = 12;
const int CFG_RIGIBIN           = 13;
const int CFG_TMPDIR            = 14;
const int CFG_RIGIDBPORT        = 15;
const int CFG_RIGIDBHOST        = 16;
const int CFG_RIGITITLE         = 17;
const int CFG_TEXTEDITOR        = 18;
const int CFG_WEBROOT           = 19;
const int CFG_WEBBROWSER        = 20;
const int CFG_ROOTLOCATION      = 21;
const int CFG_ROOTFRAMEDIM      = 22;
const int CFG_ROOTWINDOWDIM     = 23;
const int CFG_MAXCANVASDIM      = 24;
const int CFG_NUMBACKSTORES     = 25;
const int CFG_GRAPHFONT         = 26;
const int CFG_WORKBENCHFONT     = 27;
const int CFG_DEMOFONT          = 28;
const int CFG_MESSAGEFONT       = 29;
const int CFG_TEXTFONT          = 30;
const int CFG_CANVASCOLOR       = 31;

// Size of the default arrays
const int CFG_CONFIG_SIZE       = 32;

#endif	//CFGDATA_H_
