// $Author: jmcdanie $
// $Date: 1996-03-21 02:39:35 $
// $Source: /root/cvs/Rigi/rigiedit/cl_attribute.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

#ifndef ATTRIBUTE_H
#define ATTRIBUTE_H

#ifndef AVLSET_H
#include "cl_avlset.h"
#endif

#define INVALID_ATTR       (-1)


class AttributeSet : private AvlSet
{

    class Attribute
    {

    public:

        char *key, *val;
        Attribute( char*k, char*v )
            { key=strdup(k); val=strdup(v); }
        Attribute( char*k, int  i )
            { static char b[16];sprintf(b,"%d",i);key=strdup(k);val=strdup(b);}
        ~Attribute() { free(key); free(val); }
    };

    static int ff( Info *attr ) { delete (Attribute*)attr; return 0; }
    static int cmp( char *a, Attribute *attr ) { return strcmp(a,attr->key); }
    static void p( Attribute *attr ) { printf("%s %s",attr->key,attr->val); }

    public:

        AttributeSet()  { }
        ~AttributeSet() { Iterate((int(*)(Info*))ff); }

        int Size()		{ return AvlSet::Size(); }
        int Empty()		{ return AvlSet::Empty(); }

        char*	First( AvlPos*& P )
        {
            Attribute *attr = (Attribute*)AvlSet::First(P);
            return attr ? attr->key : NULL;
        }
        char*	Next( AvlPos*& P )
        {
            Attribute *attr = (Attribute*)AvlSet::Next(P);
            return attr ? attr->key : NULL;
        }

        int SetAttr( char *key, char *val )
        {
            Attribute *attr = new Attribute(key,val);
            attr = (Attribute*)
                StoreInfo( (void*)key, (Info*)attr, (AvlFunc)cmp );
            if (attr) { delete attr; return 1; }
            return 0;
        }
        int SetAttr( char *key, int val )
        {
            Attribute *attr = new Attribute(key,val);
            attr = (Attribute*)
                StoreInfo( (void*)key, (Info*)attr, (AvlFunc)cmp );
            if (attr) { delete attr; return 1; }
            return 0;
        }
        char* GetAttr( char *key )
        {
            Attribute *attr = (Attribute*)
                FindInfo( (void*)key, (AvlFunc)cmp );
            return attr ? attr->val : NULL ;
        }
        int GetIntAttr( char *key )
        {
            Attribute *attr = (Attribute*)
                FindInfo( (void*)key, (AvlFunc)cmp );
            return attr ? atoi(attr->val) : INVALID_ATTR ;
        }
        int RemoveAttr( char *key )
        {
            Attribute *attr = (Attribute*)
                RemoveInfo( (void*)key, NULL, (AvlFunc)cmp );
            if (attr) { delete attr; return 1; }
            return 0;
        }

        void Print() { AvlSet::Print( (void(*)(void*))p ); }
};

#endif

