// $Author: jmartin $
// $Date: 1998-10-15 21:07:04 $
// $Source: /root/cvs/Rigi/rigiedit/cl_grapharcset.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

#ifndef GRAPHARCSET_H
#define GRAPHARCSET_H

#ifndef AVLSET_H
#include "cl_avlset.h"
#endif
#ifndef GRAPHARC_H
#include "cl_grapharc.h"
#endif
#ifndef GRAPHNODE_H
#include "cl_graphnode.h"  // for labels of src and dst nodes
#endif

class ArcSet : private AvlSet
{
    static int cmp( ArcId *id, GraphArc *a ) { return *id - a->GetId(); }
    static void p( GraphArc *a )
    { printf( "%7d %2d %s %s", a->GetId(),a->GetType(),
                a->GetSrc()->GetLabel(),a->GetDst()->GetLabel() ); }
    public:

    ArcSet()	{}
    ~ArcSet()	{}

    int Empty()	{ return AvlSet::Empty(); }
    int Size()	{ return AvlSet::Size(); }

    int Add( GraphArc *a )
    {
        ArcId id = a->GetId();
        return a!=(GraphArc*)StoreInfo( (void*)&id,(Info*)a,(AvlFunc)cmp );
    }
    GraphArc *Remove( GraphArc *a )
    {
        ArcId id = a->GetId();
        return (GraphArc*)RemoveInfo( (void*)&id,NULL,(AvlFunc)cmp );
    }

    GraphArc *Remove( ArcId id )
    { return (GraphArc*)RemoveInfo( (void*)&id,NULL,(AvlFunc)cmp ); }

    GraphArc *Find( ArcId id )
    { return (GraphArc*)FindInfo( (void*)&id, (AvlFunc)cmp ); }

    GraphArc *First()          { return (GraphArc*)AvlSet::First(); }
    GraphArc *Last()           { return (GraphArc*)AvlSet::Last(); }

    GraphArc *First(AvlPos*&P) { return (GraphArc*)AvlSet::First(P); }
    GraphArc *Next(AvlPos*&P)  { return (GraphArc*)AvlSet::Next(P); }
    GraphArc *Last(AvlPos*&P)  { return (GraphArc*)AvlSet::LastInfo(P); }
    void Delete(AvlPos*&P)    { AvlSet::Delete(P); }

    GraphArc*  Iterator( GraphArc*(*f)(GraphArc*) )
    { return (GraphArc*)AvlSet::Iterate((int(*)(Info*))f); }

    void Print()	{ AvlSet::Print( (void(*)(void*))p ); }


    // Add/Remove/Find/First with more flexible ordering

    int Add( GraphArc *a, int(*f)(GraphArc*,GraphArc*) )
    { return a!=(GraphArc*)StoreInfo( (Info*)a,(Info*)a,(AvlFunc)f ); }

    GraphArc *Remove( GraphArc *a, int(*f)(GraphArc*,GraphArc*) )
    { return (GraphArc*)RemoveInfo( (void*)a,NULL,(AvlFunc)f ); }

    GraphArc *Find( GraphArc *a, int(*f)(GraphArc*,GraphArc*) )
    { return (GraphArc*)FindInfo( (void*)a, (AvlFunc)f ); }

    GraphArc *First(AvlPos*&P,GraphArc*a,int(*f)(GraphArc*,GraphArc*))
    { return (GraphArc*)AvlSet::First(P,(void*)a,(AvlFunc)f); }
};

#endif
