// $Author: jmcdanie $
// $Date: 1996-03-21 02:39:39 $
// $Source: /root/cvs/Rigi/rigiedit/cl_graphnodeset.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

#ifndef GRAPHNODESET_H
#define GRAPHNODESET_H

#ifndef AVLSET_H
#include "cl_avlset.h"
#endif
#ifndef GRAPHNODE_H
#include "cl_graphnode.h"
#endif

class NodeSet : private AvlSet
{
        static int cmp( NodeId *id, GraphNode *n )
            { return *id - n->GetId(); }
        static void print( GraphNode *n )
            { printf( "%-7d %s", n->GetId(),n->GetLabel() ); }

    public:

        NodeSet() {}
        ~NodeSet() {}

        int Add( GraphNode *n )
        {
            NodeId id = n->GetId();
            return n!=(GraphNode*)StoreInfo((void*)&id,(Info*)n,(AvlFunc)cmp);
        }

        GraphNode *Remove( NodeId id )
        {
            return (GraphNode*)RemoveInfo( (void*)&id, NULL, (AvlFunc)cmp );
        }

        GraphNode *Find( NodeId id )
        {
            return (GraphNode*)FindInfo( (void*)&id, (AvlFunc)cmp );
        }

        int         Insert( GraphNode *n ) { return Add(n); }
        GraphNode*  Remove( GraphNode *n ) { return Remove( n->GetId() ); }
        GraphNode*  Find( GraphNode *n )   { return Find( n->GetId() ); }
        int         Size()                 { return AvlSet::Size(); }
        int         Empty()                { return AvlSet::Empty(); }

        GraphNode*  First()          { return(GraphNode*)AvlSet::First();}
        GraphNode*  Last()           { return(GraphNode*)AvlSet::Last();}

        GraphNode*  First(AvlPos*&P) { return(GraphNode*)AvlSet::First(P);}
        GraphNode*  Next(AvlPos*&P)  { return(GraphNode*)AvlSet::Next(P); }

        GraphNode*  Iterator( GraphNode*(*f)(GraphNode*) )
            { return (GraphNode*)AvlSet::Iterate((int(*)(Info*))f); }

        void Print() { AvlSet::Print( (void(*)(void*))print ); }
};

#endif

