//
// cl_hashnodelist.c - Implementation of a hash list of Nodes.
//

// $Author: jmcdanie $
// $Date: 1996-08-23 23:12:04 $
// $Source: /root/cvs/Rigi/rigiedit/cl_hashnodelist.C,v $
// $Locker:  $
// $State: Exp $

const static char rcsid[] = "$Id: cl_hashnodelist.C,v 1.11 1996-08-23 23:12:04 jmcdanie Exp $";

//------------------------------------------------------------------------

#ifndef HASHNODELIST_H
#include "cl_hashnodelist.h"
#endif
#ifndef GRAPHNODE_H
#include "cl_graphnode.h"
#endif
#ifndef RIGIERR_H
#include "rigierr.h"
#endif

static GraphNode *hashNode = NULL;

HashNodeList::HashNodeList(unsigned int size) : HashTbl(size = CLTN_DEFAULT_CAPACITY)
{
}

HashNodeList::HashNodeList() : HashTbl(CLTN_DEFAULT_CAPACITY)
{
}

HashNodeList::~HashNodeList() {
}

RigiBool HashNodeList::Create(GraphNode& ) {
    mayday("HashNodeList::Create - Should not be called");
    return RigiFalse;
}


RigiBool HashNodeList::Add(RigiObject& node) {
    int num = this->Size();
    return (RigiBool) ((HashTbl::Add((RigiObject*)&node)) == NIL);
}

GraphNode* HashNodeList::Find(const NodeId id) {
    if (hashNode == NULL) hashNode = new GraphNode(NULL);
    hashNode->SetId(id);
    GraphNode* tmp = (GraphNode*) HashTbl::Find((RigiObject*)hashNode);
    return tmp ;
}

GraphNode* HashNodeList::Remove(const NodeId id) {
    if (hashNode == NULL) hashNode = new GraphNode(NULL);
    hashNode->SetId(id);
    GraphNode* tmp = (GraphNode*) HashTbl::Remove((ObjectPtr)hashNode);
    return tmp ;
}


RigiBool HashNodeList::operator==(const HashNodeList& a) {
    return (HashTbl::operator==(*((HashTbl*)&a)));
}    

void HashNodeList::operator=(const HashNodeList& a) {
    HashTbl::operator=(*((HashTbl*)&a));
}


void HashNodeList::operator&(const HashNodeList& a) {
    HashTbl::operator&(*((HashTblPtr)&a));
}       

void HashNodeList::operator|(const HashNodeList& a) {
    HashTbl::operator|(*((HashTblPtr)&a));
}       

void HashNodeList::operator-(const HashNodeList& a) {
    HashTbl::operator-(*((HashTblPtr)&a));
}       

