//
// File:    rigiarc.h
// Author:  Brian Corrie
// Date:    January 16, 1991
// Project: Rigi V4.0
//

// $Author: jmcdanie $
// $Date: 1996-03-21 02:39:39 $
// $Source: /root/cvs/Rigi/rigiedit/cl_rigiarc.h,v $
// $Locker:  $
// $State: Exp $

//------------------------------------------------------------------------

#ifndef RIGIARC_H
#define RIGIARC_H

#ifndef LIST_H
#include "cl_list.h"           // Base class for RigiArcList
#endif

class GraphArc;
class RigiWindow;
class RigiNode;
class RigiArc;


class RigiArcList : private List
{
public:

    // Constructor and destructor for this class.

    RigiArcList() {}
    ~RigiArcList() {}

    // Routines provided by this class.

    void     Insert( RigiArc* ra )  { List::Insert(ra); }
    RigiArc* First()                { return (RigiArc *)List::First(); }
    RigiArc* Next()                 { return (RigiArc *)List::Next(); }
    int      GetNoItems()           { return List::GetNoItems(); }
    void     Empty()                { List::Empty(); }
};

class RigiArc
{
private:

    GraphArc*    arc;       // Pointer to actual arc
    RigiWindow*  window;    // Window for this arc

public:

    // Constructor and destructor for the class.

    RigiArc( GraphArc*, RigiWindow* );
    ~RigiArc();

    GraphArc*    GetArc()          { return arc; };
    RigiWindow*  GetWindow()       { return window; }

    GraphArc*    SetNull();

    RigiNode*    GetDst();
    RigiNode*    GetSrc();
    RigiNode*    GetOther( RigiNode* );
    int          isVisible();

    void         Draw();
};

#endif
