// $Author: jmcdanie $
// $Date: 1996-03-21 02:39:39 $
// $Source: /root/cvs/Rigi/rigiedit/cl_rigiarcset.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

#ifndef RIGIARCSET_H
#define RIGIARCSET_H

#include <stdio.h>       // printf

#ifndef AVLSET_H
#include "cl_avlset.h"  // Base class
#endif
#ifndef RIGIARC_H
#include "cl_rigiarc.h"  // GetSrc() and GetDst()
#endif


// Members of this set are stored by their src or dst riginode,
// depending on whether they be in a riginode's IN or OUT arcset.

class RigiArcSet : private AvlSet
{
    static void print( RigiArc *ra )
        { printf( "src=%d dst=%d", ra->GetSrc(), ra->GetDst() ); }

    static int cmpdst( RigiNode *rn, RigiArc *ra )
    {
        if ( rn > ra->GetDst() ) return  1; else
        if ( rn < ra->GetDst() ) return -1; else
        return 0;
    }

    static int cmpsrc( RigiNode *rn, RigiArc *ra )
    {
        if ( rn > ra->GetSrc() ) return  1; else
        if ( rn < ra->GetSrc() ) return -1; else
        return 0;
    }

    public:

    RigiArcSet():AvlSet(1)  {}  // permit multiple records with equality
    ~RigiArcSet() {}

    int Size()    { return AvlSet::Size(); }
    void Empty()  { AvlSet::Empty(); }

    int Insert( RigiArc *a, RigiNode *n )
        { AvlFunc f;
        if (n==a->GetSrc()&&n!=a->GetDst()) f = (AvlFunc)cmpsrc;
            else f = (AvlFunc)cmpdst;
        return a!=(RigiArc*)StoreInfo( (void*)n, (Info*)a, f ); }

    RigiArc *Remove( RigiArc *a, RigiNode *n )
        { AvlFunc f;
        if (n==a->GetSrc()&&n!=a->GetDst()) f = (AvlFunc)cmpsrc;
            else f = (AvlFunc)cmpdst;
        return (RigiArc*)RemoveInfo( (void*)n, (Info*)a, f ); }

    RigiArc *Find( RigiNode *n )
        { return (RigiArc*)FindInfo( (void*)n, (AvlFunc)cmpdst ); }

    RigiArc* First(AvlPos*&P){ return(RigiArc*)(AvlSet::First(P));}
    RigiArc* Next(AvlPos*&P) { return(RigiArc*)(AvlSet::Next(P)); }
    RigiArc* Last(AvlPos*&P) { return(RigiArc*)(AvlSet::LastInfo(P)); }

    RigiArc* Iterator( RigiArc*(*f)(RigiArc*) )
        { return (RigiArc*)(AvlSet::Iterate((int(*)(Info*))f)); }

    void Print() { AvlSet::Print( (void(*)(void*))print ); }
};

#endif
