// $Author: jmcdanie $
// $Date: 1996-03-21 02:39:40 $
// $Source: /root/cvs/Rigi/rigiedit/cl_riginodeset.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

#ifndef RIGINODESET_H
#define RIGINODESET_H

#ifndef AVLSET_H
#include "cl_avlset.h"    // base class
#endif

#ifndef RIGINODE_H
#include "cl_riginode.h"   // for printing contents
#endif
#ifndef GRAPHNODE_H
#include "cl_graphnode.h"  // for printing contents
#endif

class RigiNodeSet : private AvlSet
{
    static void print( RigiNode *n )
        { printf( "%d %s", n->GetNode()->GetId(),n->GetNode()->GetLabel() ); }

    public:

        RigiNodeSet():AvlSet(1) {}
        ~RigiNodeSet() {}

        int Size()	{ return AvlSet::Size(); }
        void Empty()	{ AvlSet::Empty(); }

        // Specialized Insert() required for sorting by position

        int Insert( RigiNode *a, int(*f)(RigiNode*,RigiNode*)=NULL )
            { return a!=(RigiNode*)StoreInfo((void*)a,(Info*)a,(AvlFunc)f); }

        RigiNode *Remove( RigiNode *a )
            { return (RigiNode*)RemoveInfo( (void*)a, NULL ); }

        RigiNode *Find( RigiNode *a )
            { return (RigiNode*)FindInfo( (void*)a ); }


        RigiNode* First(AvlPos*&P){ return(RigiNode*)(AvlSet::First(P));}
        RigiNode* Next(AvlPos*&P) { return(RigiNode*)(AvlSet::Next(P)); }

        RigiNode*	Iterator( RigiNode*(*f)(RigiNode*) )
            { return (RigiNode*)(AvlSet::Iterate((int(*)(Info*))f)); }

        void Print() { AvlSet::Print( (void(*)(void*))print ); }
};

#endif
