// $Author: jmcdanie $
// $Date: 1996-08-23 23:21:16 $
// $Source: /root/cvs/Rigi/rigiedit/graphutil.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

#ifndef GRAPHUTIL_H
#define GRAPHUTIL_H

class GraphNode;
class GraphArc;
class RigiWindow;
class RigiNode;
class RigiNodeList;

// Check to see if the RigiNodes given are in the given RigiWindow.
extern RigiBool GutilCheckList(RigiNodeList&,RigiWindow*);

// Check to see if a node or arc exists in the graph

extern GraphNode*  GutilNodeExists(int);
extern GraphArc*   GutilArcExists(int);

extern GraphNode*  GutilCreateNode( GraphNode*, char*, int );
extern GraphArc*   GutilCreateArc( GraphNode*, GraphNode*, int );

extern void GutilAddArc( GraphArc* );
extern void GutilAddNode( GraphNode* );
extern RigiBool GutilDeleteArc( GraphArc* );
extern void GutilDeleteNode( GraphNode* );
extern void GutilDeleteNodesWindows( GraphNode* );

extern void GutilChangeNodeName( GraphNode*, char* );
extern void GutilChangeNodeId( GraphNode*, int );
extern void GutilChangeArcType( GraphArc*, int );

extern RigiNode *GutilNewNode( RigiWindow *rw, char *name, int type, int x, int y );
extern GraphArc *GutilNewArc( RigiWindow *rw, int type, RigiNode *sn1, RigiNode *sn2);



#endif

