// $Author: mwhitney $
// $Date: 1995-11-10 23:14:47 $
// $Source: /root/cvs/Rigi/rigiedit/memchk.C,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

//#define BEGINCHECK

#ifndef STREAMH
#include <stream.h>
#endif
#ifndef __STDIO_H
#include <stdio.h>
#endif
#ifndef __STDLIB_H
#include <stdlib.h>
#endif
#ifndef __STRING_H
#include <string.h>
#endif
#ifndef MEMCHK_H
#include "memchk.h"
#endif

#ifndef _CCHEADER_H_
#include "CCheader.h"
#endif
#ifndef GRAPHERR_H
#include "grapherr.h"           // Want to include low level stdio error funcs
#endif

#include "avl.h"

#ifdef MOTIF
extern RigiBool XKW;
#ifdef BEGINCHECK
static int XMJW=1;
#else
extern int XMJW;
#endif
#else
static int XMJW=0;
static RigiBool XKW=0;
#endif


static int mem_used = 0;
static int new_calls = 0;
static int del_calls = 0;
static Avlset newset = 0;

int	MemoryUse()		{ return mem_used; }
int	MemoryNew()		{ return new_calls; }
int	MemoryDelete()		{ return del_calls; }

//#if sun
#if 0

static int space_debug = 0;
static char *executable_name = "rigiedit";

void MemoryDebugInit( char *prog )
{
    executable_name = prog;
}

int MemoryDebugOn()
{
    space_debug++;
    return space_debug;
}

int MemoryDebugOff()
{
    space_debug--;
    return space_debug;
}

static int number_of_calls;
static int first_time = 1;
static FILE *space_out;
struct symlist
{
        char *name;
        int address;
};

#define START_SIZE 1000
static  int     symlist_count;
static  struct  symlist *slist;
void read_sym ()
{
        int     symlist_size = START_SIZE;

        slist = (struct symlist *) 
                malloc (sizeof (struct symlist) * symlist_size);
        char    name[512];

        fprintf (stderr, "creating symtab...");
        sprintf (name, "nm %s | egrep ' t | T ' | sort +0 -1 +1r > symtab",
                executable_name);
        system (name);
        fprintf (stderr, "done\n");
        FILE *infile = fopen ("symtab", "r");
        if (infile == NULL)
        {
                fprintf (stderr, "error opening symtab\n");
                exit (1);
        }

        int     address;
        char    type;

        symlist_count = 0;
        while (fscanf (infile, "%x %c %s", &address, &type, name) != EOF)
        {
                slist[symlist_count].address = address;
                slist[symlist_count].name = malloc (strlen (name) + 1);
                strcpy (slist[symlist_count].name, name);

                if (++symlist_count >= symlist_size)
                {
                        symlist_size += START_SIZE;
                        slist = (struct symlist *) 
                                realloc ((char *) slist, 
                                        sizeof (struct symlist) * symlist_size);
                }
        }
       symlist_count--;
}

void print_sym (unsigned address)
{
        int lower = 0;
        int middle;
        int upper = symlist_count;

        if (address < slist[lower].address)
        {
                fprintf (space_out, " the operating system ");
                return;
        }

        if (address > slist[upper].address)
        {
                fprintf (space_out, " in outer space ");
                return;
        }

        while (1)
        {
                middle = (upper + lower) / 2;

                if (address > slist[middle].address && 
                        address < slist[middle + 1].address)
                {
                        fprintf (space_out, "%s", slist[middle].name);
                        int i = middle; 
                        do
                        {
                                i--;
                        }
                        while (slist[i].name[0] == '_' ||
                                !strcmp (slist[i].name, "gcc_compiled."));

                        fprintf (space_out, " in %s ", slist[i].name);
                        break;
                }
                else if (lower >= upper)
                {
                        fprintf (space_out, " an unknown address ");
                        return;
                }
                else
                {
                        if (address < slist[middle].address)
                       {
                               upper = middle;
                       }
                       else
                       {
                               lower = middle;
                       }
                }
        }
}

void* operator new(size_t size)
{

#if sun && (mc68000 || mc68020)
        int i;
        int address = (*(&i+2));
#endif

#if sun && sparc
        register int address;
#endif
        char *p;

#if sun && sparc && __GNUC__
        asm ("mov %i7,%l0");
#endif

#if sun && sparc && !__GNUC__
        asm ("mov %i7,%i5");
#endif
        if (space_debug)
        {
                if (first_time)
                {
                        if ((space_out = fopen ("space.raw", "w")) == NULL)
                        {
                                fprintf (stderr, "error opening space.raw\n");
                                exit (1);
                        }
                        first_time = 0;
                        read_sym ();
                }
                fprintf (space_out, "new(%d) called in: ", size);
                print_sym (address);
        }
	p = malloc(unsigned (size));

        if ( size && p==0 )
        {
                fprintf (stderr,
		"out of malloc space, tried to allocate %d bytes\n",size);
                exit (1);
        }
        if (space_debug)
        {
                fprintf (space_out, "returning: %08x %08d\n", 
                        p, number_of_calls);
                ++number_of_calls;
        }

	mem_used += size;
	new_calls ++;
	if (XMJW==1) {
	    if (!newset) newset = NewSet(2);
	    SetInfo( newset, (char*)p, (int)size );
	    if(XKW)printf("MJW, setattr 0x%x to %d\n",p,size );
	}
        return (void*)p;
}

void operator delete(void* p)
{

#if sun && (mc68000 || mc68020)
    int i;
    int address = (*(&i+2));
#endif

#if sun && sparc
    register int address;
#endif

#if sun && sparc && __GNUC__
    asm ("mov %i7,%l0");
#endif

#if sun && sparc && !__GNUC__
    asm ("mov %i7,%i5");
#endif

    if (space_debug)
    {
        if (first_time)
        {
            if ((space_out = fopen ("space.raw", "w")) == NULL)
            {
                fprintf (stderr, "error opening space.raw\n");
                exit (1);
            }
            first_time = 0;
            read_sym ();
        }
        fprintf (space_out, "delete called in: ");
        print_sym (address);

        fprintf (space_out, "with: %08x %08d\n", p, number_of_calls);
        ++number_of_calls;
    }

    del_calls ++;

    if (newset)
    {
        int size = SetInfo( newset, (char*)p, INVALID );
        if (size<=0) printf("warning, no memory associated with 0x%x\n",p);
            else mem_used -= size;
        if(XKW)printf("MJW, getattr 0x%x is %d\n",p,size); 
    }

    if (p) free ((char *)p);
}

#else

void* operator new(size_t size)
{
//static int i=0;
//if (!i) { fprintf(stderr,"WARNING: overloaded new/delete in use\n");i=1; }

    void *p = malloc (unsigned (size));
    if ( size && p==0 )
    {
	fprintf (stderr,
	"out of malloc space, tried to allocate %d bytes\n",size);
	exit (1);
    }
    mem_used += size;
    new_calls ++;
    if (XMJW==1)
    {
        if (!newset) newset = NewSet(2);
        SetInfo( newset, (char*)p, (int)size );
        if(XKW)printf("MJW, setattr 0x%x to %d\n",p,size );
    }
    return (void*)p;
}

void operator delete(void* p)
{
    if (newset)
    {
	int size = SetInfo( newset, (char*)p, INVALID );
	if (size<=0) printf("warning, no memory associated with 0x%x\n",p);
	    else mem_used -= size;
	if(XKW)printf("MJW, getattr 0x%x is %d\n",p,size); 
    }

    if (p) free ((char *)p);
    del_calls ++;
}

void	MemoryDebugInit(char*)	{ }
int	MemoryDebugOn()		{ return 0; }
int	MemoryDebugOff()	{ return 0; }

#endif

