function rindex(haystack, needle,     x1, x2) {
  x2 = 0;
  do {
    x1 = x2;
    x2 = x2 + index(substr(haystack, x1 + 1), needle);
  } while (x2 > x1);
  return x1;
}

function showdeps(strings,     names, i) {
  split(strings, names, " ");
  for (i in names) {
    printf("%s ", names[i]);
    if (names[i] in deps)
      showdeps(deps[names[i]]);
  }
}

FNR == 1                        { filename = FILENAME;
                                  numdeps  = 0;
                                }
/^[ \t]*\#include[ \t]+\"[^:]*\"/       {
                                  split($0, fields, "\"");
                                  if (numdeps == 0)
                                    deps[ filename ] = fields[2];
                                  else
                                    deps[ filename ] = deps [ filename ] " " fields[2];
                                  numdeps++;
                                }
END                             {
                                  for (name in deps) {
                                    dotpos    = rindex(name, ".");
                                    basename  = substr(name, 1, dotpos - 1);
                                    dirpos    = rindex(basename, "/");
                                    if (dirpos > 0)
                                      basename  = substr(basename, dirpos + 1);
                                    nameextension = substr(name, dotpos + 1);
                                    if (match(nameextension, "[cC]")) {
                                      printf("%s.o: %s ", basename, name);
                                      showdeps(deps[name]);
                                      printf("\n");
                                    }
                                    if (match(nameextension, "[yl]")) {
                                      printf("%s.o: ", basename);
                                      showdeps(deps[name]);
                                      printf("\n");
                                    }
                                  }
                                }
