// $Author: jmartin $
// $Date: 2000-02-05 02:18:33 $
// $Source: /root/cvs/Rigi/rigiedit/rigi_init.C,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------


#ifndef DOMAIN_H
#include "cl_domain.h"		// Class definitions
#endif
#ifndef GLOBAL_H
#include "global.h"
#endif

#ifndef RIGISTATE_H
#include "cl_rigistate.h"               // Global instance of editor's state
#endif
#ifndef TK_COLORMAP_H
#include "tk_colormap.h"
#endif
#ifndef GRAPHERR_H
#include "grapherr.h"
#endif
#ifndef GRAPHUTIL_H
#include "graphutil.h"
#endif
#include "environ.h"
#ifndef _ICON_H
#include "icon.h"
#endif
#ifndef RIGI_H
#include "rigi.h"
#endif

//***********************************************************************
// The current domain in use. Note that for the domain to be created
// properly, the Rigi environment variables module must be initialized
// first (EnvInit())

static RigiDomain *rigidomain = NULL;
static int domaininit = 0;

void RinitDomain() {
    rigidomain = new RigiDomain();
    domaininit = 1;
}

RigiDomain* RinitGetDomain() {
    // Warn if we have initialized the module and the domain is NULL.
    // If we haven't initialized the module then the domain can be NULL.

    if (domaininit && rigidomain == NULL)
        mayday("NULL rigidomain in RinitGetDomain()");
    return rigidomain;
}

int RinitInit( char *domain ) {
    // If the old domain exists, delete it. Then create a new domain.

    if (rigidomain) delete rigidomain;
    rigidomain = new RigiDomain( domain );
    domaininit = 1;

    // Set the current arc type to be the level arc of the new domain

    editor->SetArcType( editor->LevelArc() );
    editor->ClearArcSet();

    return 1;
}

//***********************************************************************
// update the Rigicolor file

void RinitWriteColors() {
    FILE *fp;
    RigiColor col;

    CharType filebuff;
    filebuff.Assign( EnvDomainDir() );
    filebuff.Append( "/Rigicolor" );
    fp = fopen( filebuff.string(), "w" );
    if ( fp==NULL )
    {
        mayday("Couldn't open color file %s for writing!", filebuff.string());
        return;
    }

    int num_nodes = rigidomain->NumNodeTypes();
    int i;
    for (i=0; i<num_nodes; i++ )
    {
        rigidomain->GetNodeColor(i, &col);
        fprintf( fp, "%d %d %d\n", col.red, col.green, col.blue);
    }
    int num_arcs = rigidomain->NumArcTypes();
    for ( i=0; i<num_arcs; i++ )
    {
        rigidomain->GetArcColor(i, &col);
        fprintf( fp, "%d %d %d\n", col.red, col.green, col.blue );
    }
    fclose(fp);
}

