
// $Author: jmcdanie $
// $Date: 1996-05-11 23:46:58 $
// $Source: /root/cvs/Rigi/rigiedit/rigierr.C,v $
// $Locker:  $
// $State: Exp $

const static char rcsid[] = "$Id: rigierr.C,v 1.31 1996-05-11 23:46:58 jmcdanie Exp $";

//------------------------------------------------------------------------

#ifndef STREAMH
#include <stream.h>
#endif
#include <stdarg.h>	// for varargs stuff
#include <tcl.h>	// for tcl calls
#include "rcl_commands.h"

#ifndef RIGIERR_H
#include "rigierr.h"
#endif
#ifndef GLOBAL_H
#include "global.h"
#endif
#ifndef RIGI_H
#include "rigi.h"
#endif
#ifndef RIGIWINDOW_H
#include "cl_rigiwindow.h"
#endif
#ifndef CSTUFF_H
#include "cstuff.h"
#endif


extern char *progname;
extern RigiBool VERBOSE;

const int ALERT = 0 ;
const int ERRORFLAG = 1 ;
const int EXIT = 2 ;

const int BAD_ANSWER = 0;
const int YES_ANSWER = 1;
const int NO_ANSWER = 2;

static const int MaxMsgSize = 1024;

// errorState of widget response:
// 0 - no error, no stack dump
// 1 - error, no stack dump
// 2 - error, stack dump
static int errState = 0;    // bit flag

int RigiErrState() {
    int i = errState;
    errState = 0;
    return (i == 2)? TCL_ERROR : TCL_OK;
}


int RigiError( int code, char* format ...) {
    static char message[MaxMsgSize];
    int e;

    va_list ap;
    va_start(ap, format);
    vsprintf(message, format, ap);
    va_end(ap);

    switch( code ) {
    case ALERT:
        Tcl_AppendResult(rcl_interp, "\nAlert: ", 0);
        Tcl_AppendResult(rcl_interp, message, 0);
        warn(message);
        if (errState < 2) {
            e = RigiDlg(code, message);
            if (e > errState) errState = e;
        }
        if (!errState) return 1;
        break;
    case ERRORFLAG:
        Tcl_AppendResult(rcl_interp, "\nError: ", 0);
        Tcl_AppendResult(rcl_interp, message, 0);
        mayday(message);
        if (errState < 2) {
            e = RigiDlg(code, message);
            if (e > errState) errState = e;
        }
        break;
    case EXIT:
        cerr << "RigiError: " << message << endl ;
        cerr << endl ;
        errState = 1;
        exit(-1) ;
    default:
        cerr << "RigiError: Unknown error code.\n";
        cerr << "RigiError: " << message << endl;
        cerr << endl;
        errState = 1;
    }
    return 0;
}

RigiBool RigiDlg(int code, char *message ) {
    char *title;

    switch (code) {
    case ALERT:
        title = "Alert";
        break;
    case ERRORFLAG:
        title = "Error";
        break;
    default:
        title = "";
    }
    CharType msgBuff("w_rigierr .rigi.rigierr \"");
    for (int i = 0; message[i]; i++)
        if (message[i] == '"') message[i] = '\'';
    msgBuff.Append(message);
    msgBuff.Append("\" \"");
    msgBuff.Append(title);
    msgBuff.Append("\"");

    char *result = exec_command(msgBuff.string());
    return (*result == '0' || *result == '1')? atoi(result) : 2;
}

