
// $Author: jmcdanie $
// $Date: 1996-03-21 02:39:53 $
// $Source: /root/cvs/Rigi/rigiedit/tk_filter.h,v $
// $Locker:  $
// $State: Exp $

//------------------------------------------------------------------------

#ifndef FILTERPANEL_H
#define FILTERPANEL_H

#include "CCheader.h"
#include "cl_flag.h"
#include "adt/object.h"

// The filter dialog window is a custom dialog window made just for the
// filter panel.  It is not flexible like the other dialog windows in that
// it always looks the same.

class FilterDialogWindow
{
    private:
        // The following are used so that arc flags and node flags are not
        // applied until the apply button in the filter panel is pressed
        int       parent_id;
        BitSet*   arcflag;     // For setting arc filters
        BitSet*   nodeflag;    // For setting node filters			

    public:

        FilterDialogWindow( char* str, int id );
        FilterDialogWindow( char* str, int id, BitSet *nflag, BitSet *aflag );
        ~FilterDialogWindow();

        // Methods to create, destory, and display the windows for the class
        // Initialize() creates the window dependant stuff, Destroy() releases
        // any resources allocated by Initialize().
        void Initialize();
        void Destroy();
        void RigiDisplay();

        // The following are used so that arc flags and node flags are not
        // applied until the apply button in the filter panel is pressed

        int  GetNodeFlag( int bit );
        void SetNodeFlag( int bit );
        void ClearNodeFlag( int bit );
        void FlipNodeFlag( int );

        int  GetArcFlag( int bit );
        void SetArcFlag( int bit );
        void ClearArcFlag( int bit );
        void FlipArcFlag( int );

        int	GetParentId();

        void	Update();
        void	UpdateNodeLabels();
        
        // Used for craigs hashing stuff
        RigiBool operator==(const FilterDialogWindow&) const;
        void operator=(const FilterDialogWindow&);

        // Routines required by a Object class and derived classes

        virtual RigiBool isEqual(void* a) const;
        virtual void* Duplicate() { return (NIL); } // not implemented
        virtual void* Create() { return (NIL); } // not implemented
        virtual void Delete_type(ObjectPtr) {} // not implemented
}; 

#endif
