
// $Author: jmcdanie $
// $Date: 1996-05-24 00:35:03 $
// $Source: /root/cvs/Rigi/rigiedit/treelists.C,v $
// $Locker:  $
// $State: Exp $

const static char rcsid[] = "$Id: treelists.C,v 1.17 1996-05-24 00:35:03 jmcdanie Exp $";

//------------------------------------------------------------------------

#ifndef STREAMH
#include <stream.h>
#endif
#ifndef __STRING_H
#include <string.h>
#endif

#ifndef CSTUFF_H
#include "cstuff.h"
#endif
#ifndef TREELISTS_H
#include "treelists.h"
#endif

#ifndef GLOBAL_H
#include "global.h"
#endif
#ifndef RIGISTATE_H
#include "cl_rigistate.h"   // Global instance of editor's state
#endif

#ifndef DOMAIN_H
#include "cl_domain.h"      // Domain
#endif
#ifndef RIGIINIT_H
#include "rigi_init.h"      // RinitGetDomain
#endif

ArcSet depfrom,depinto ;
HashNodeList children;
HashNodeList leaves;

static ArcType typetouse;
static int     usealltypes = 1;

void TreeSetType( ArcType type )
{
    usealltypes = 0;
    typetouse = type;
}

void TreeUseAllTypes()
{
    usealltypes = 1;
}

void TreeInitLists()
{
    depfrom.Empty();
    depinto.Empty();
    children.Empty();
    leaves.Empty();
}

void TreeMakeLists( GraphNode* n ) {
    ArcDirection dir;
    GraphArc* a;
    AvlPos *P;
    int ntypes = RinitGetDomain()->NumArcTypes();
    int lt = editor->LevelArc();
    int ct = editor->CompositeArc();
    int t;

    // Add this node to the child list.

    children.Add(*n);

    // If the node does not have any outgoing level arcs, add it to the
    // list of leaf nodes.

    a = n->FirstArc( P, lt, dir );
    if (!a) leaves.Add(*n);

    // For each outgoing arc that is not composite or level,
    // add it to the depfrom list.

    dir = ARC_OUT;
    for ( t=0; t<ntypes; t++ ) {
        if (t==lt) continue;
        if (t==ct) continue;

        for ( a=n->FirstArc(P, t, dir ); a; a=n->NextArc(P, t, dir) )
            if (usealltypes==RigiTrue || t==typetouse) depfrom.Add(a);
    }

    // For each incoming arc that is not composite or level,
    // add it to the depinto list.

    dir = ARC_IN;
    for ( t=0; t<ntypes; t++ ) {
        if (t==lt) continue;
        if (t==ct) continue;

        for ( a=n->FirstArc(P, t, dir); a; a=n->NextArc(P,t, dir) )
            if (usealltypes==RigiTrue || t==typetouse) depinto.Add(a);
    }
}
