
// $Author: jmcdanie $
// $Date: 1996-05-11 23:46:59 $
// $Source: /root/cvs/Rigi/rigiedit/viewops.C,v $
// $Locker:  $
// $State: Exp $

const static char rcsid[] = "$Id: viewops.C,v 1.20 1996-05-11 23:46:59 jmcdanie Exp $";

//------------------------------------------------------------------------


#ifndef STREAMH
#include <stream.h>
#endif
#include <sys/types.h>

// Definition include files
#ifndef _CCHEADER_H_
#include "CCheader.h"            // C++ base definitions
#endif
#ifndef CSTUFF_H
#include "cstuff.h"
#endif
#ifndef RIGIWINDOW_H
#include "cl_rigiwindow.h"       // Class definition for RigiWindows
#endif
#ifndef GLOBAL_H
#include "global.h"              // Global definitions for the editor
#endif
#ifndef VIEWOPS_H
#include "viewops.h"             // Include the definitions for this file
#endif

// Utility include files
#ifndef RIGI_H
#include "rigi.h"                // Basic control functions for the editor
#endif
#ifndef RIGIERR_H
#include "rigierr.h"             // Basic control functions for the editor
#endif
#ifndef GRAPHUTIL_H
#include "graphutil.h"           // Data base & object creation utilities
#endif
#include "win_util.h"            // Window state access functions
#ifndef RIGIINIT_H
#include "rigi_init.h"
#endif
#include "environ.h"
#ifndef VIEW_H
#include "view.h"                // View operations
#endif

const int SAVEVIEW = 0;
const int LOADVIEW = 1;

// Load or save the view according to the operation selected
void ViewOp(int whichop, char* selection)
{
    WindowSetCursor( CURSOR_WAIT );

    switch (whichop){
    case SAVEVIEW:
        if ( !ViewWrite( selection ) )
            RigiError(ERRORFLAG, "Unable to save view");
        break;
    case LOADVIEW:
        if ( !ViewRead( selection ) )
            RigiError(ERRORFLAG, "View did not load correctly");
        break;
    default:
        break;
    }
    WindowSetCursor(CURSOR_NORMAL);
}

